{=======================================================================================================================

  Comming BASE

    ,  .
             (taData).

========================================================================================================================

  :

  07.10.2012 [*] .
  16.05.2008 [+]    .
  15.11.2005 [*]     .
  14.11.2005 [+]    "".
  25.01.2004 [-]   ,  .
             [+]  constructor.
             [+]    .
  08.07.2003 [+]   .
  12.05.2003 [+]   - (  DefaultExpression   )
                  .
  24.01.2003 [*] btSave: Hint.
  21.11.2002 [*]  ImageList.
  23.08.2002 [*]  TAfterPost.
  19.08.2002 [*]   TcoButton.
  23.01.2002 [-] .
             [+]  .
  15.12.2001 [+]  DatsaSet  .
             [+]   DataSet   .
  26.11.2001 [*]      Windows 9x.
  16.08.2001 [*]  .
  08.06.2001 [+]  .
  06.04.1999 [!]   BASE.

========================================================================================================================
  Copyright 19992012 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: BASEfrEdit.pas,v 1.11 2012/10/22 07:05:37 tsk Exp $
=======================================================================================================================}
unit BASEfrEdit;

interface

uses  Windows, Messages, SysUtils, Classes, Controls, Forms, DB, StdCtrls, ExtCtrls, ADODB,
      // BASE:
      BASEfrRoot,
      // Comming:
      CommingButton, CommingADO;

type

  TAfterPost = procedure of object;
  TAfterPostKey = procedure ( Key: Variant ) of object;
  TAfterCancel = procedure of object;

  TBASEEditFR = class( TBASERootFR )
    btSave: TcoButton;
    dsData: TDataSource;
    laTitle: TStaticText;
    taData: TADODataSet;
    procedure dsDataStateChange(Sender: TObject);
    procedure btSaveClick(Sender: TObject);
    procedure btCancelClick(Sender: TObject);
    procedure taDataAfterInsert(DataSet: TDataSet);
    procedure taDataAfterPost(DataSet: TDataSet);
    procedure taDataBeforePost(DataSet: TDataSet);
  private   { Private declarations }
  public    { Public declarations }
    AfterPost:    TAfterPost;
    AfterPostKey: TAfterPostKey;
    AfterCancel:  TAfterCancel;
    constructor CreateComming( AOwner: TComponent; AProc: TAfterPostKey );
  end;

implementation

uses Math;

{$R *.DFM}
//======================================================================================================================
{ TBASEEditFR }
//======================================================================================================================
constructor TBASEEditFR.CreateComming(AOwner: TComponent; AProc: TAfterPostKey);
begin
  inherited Create(AOwner);
  AfterPostKey := AProc;
end;
//======================================================================================================================
procedure TBASEEditFR.dsDataStateChange(Sender: TObject);
begin
  btSave.Enabled := ( dsData.State in [dsEdit, dsInsert]);
end;
//======================================================================================================================
procedure TBASEEditFR.btSaveClick(Sender: TObject);
begin
  Screen.Cursor := crHourGlass;
  try
    dsData.DataSet.Post;
    if Assigned( AfterPost )
      then AfterPost
      else if Assigned( AfterPostKey ) then AfterPostKey( taData.Fields[0].Value );
    try
      dsData.DataSet.Close;
    except end;
    CloseModal;
  finally
    Screen.Cursor := crDefault;
  end;
end;
//======================================================================================================================
procedure TBASEEditFR.btCancelClick(Sender: TObject);
begin
  dsData.DataSet.Cancel;
  dsData.DataSet.Close;
  if Assigned( AfterCancel ) then AfterCancel;
  inherited;
end;
//======================================================================================================================
procedure TBASEEditFR.taDataBeforePost(DataSet: TDataSet);
  var i: Integer;
begin
  inherited;
  with DataSet do
    for i := 0 to FieldCount - 1 do begin
      if ( Fields[i] is TStringField ) and ( Length( Fields[i].AsString ) = 0 )
        then Fields[i].Clear;
      if ( Fields[i] is TBCDField )    and ( TBCDField(Fields[i]).currency ) and ( not Fields[i].IsNull ) 
        then Fields[i].Value := RoundTo( Fields[i].Value, -2);
    end
end;
//======================================================================================================================
procedure TBASEEditFR.taDataAfterInsert( DataSet: TDataSet );
begin
  inherited;
  LoadDefaultFromRegistry( taData );
end;
//======================================================================================================================
procedure TBASEEditFR.taDataAfterPost(DataSet: TDataSet);
begin
  inherited;
  SaveDefaultToRegistry( taData );
end;
//======================================================================================================================
end.
